Last Comment Bug 728026 - MAPLE: geolocation shows little map fragments while the map is being loaded
: MAPLE: geolocation shows little map fragments while the map is being loaded
Status: VERIFIED FIXED
[mozilla-central]
: testcase
Product: Core
Classification: Components
Component: Graphics (show other bugs)
: Trunk
: ARM Android
: P2 normal (vote)
: mozilla15
Assigned To: Joe Drew (not getting mail)
:
Mentors:
http://taurus.woot.net/~jdrew/mwc-dem...
: 739042 741173 745167 747791 748485 (view as bug list)
Depends on: 749425
Blocks: 728961
  Show dependency treegraph
 
Reported: 2012-02-16 14:49 PST by Naoki Hirata :nhirata (please use needinfo instead of cc)
Modified: 2012-05-23 04:46 PDT (History)
20 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
verified
verified
beta+


Attachments
Testcase #1 (603 bytes, text/html)
2012-04-21 19:20 PDT, Mats Palmgren (vacation)
no flags Details
don't disable the scissor rect from java (4.16 KB, patch)
2012-04-26 15:30 PDT, Joe Drew (not getting mail)
jmuizelaar: review+
Details | Diff | Splinter Review
unbitrotted (4.56 KB, patch)
2012-04-30 08:13 PDT, Joe Drew (not getting mail)
joe: review+
Details | Diff | Splinter Review
unbitrotted again (1.53 KB, patch)
2012-05-02 08:28 PDT, Joe Drew (not getting mail)
joe: review+
Details | Diff | Splinter Review
unbitrotted again (3.28 KB, patch)
2012-05-02 11:40 PDT, Joe Drew (not getting mail)
joe: review+
mark.finkle: approval‑mozilla‑aurora+
Details | Diff | Splinter Review

Description Naoki Hirata :nhirata (please use needinfo instead of cc) 2012-02-16 14:49:55 PST
1. go to http://paulrouget.com/mwc-demos/apis/geolocation.html
2. click on the icon
3. watch it load

Expected: no graphic defect while loading
Actual: you can see little map fragments while the map is being loaded

Note:
1. MAPLE 02/16/2012; Nexus Galaxy ICS/LG Revolution 2.3
2. Does not occur on nightly 02/16/2012
3. video : http://www.youtube.com/watch?v=8wvCU7IbcmU&feature=youtube_gdata_player
Comment 1 Erin Lancaster [:elan] 2012-02-17 18:38:08 PST
We are not showing this on Maple; only on nightly
Comment 2 Paul Rouget [:paul] 2012-02-21 09:50:39 PST
The APIs demo are located here: http://paulrouget.com/mwc-demos/apis/
To show the map, click on the globe.
Comment 3 Paul Rouget [:paul] 2012-02-21 10:07:49 PST
The original demo is here: http://jsbin.com/isujul
Comment 4 Joe Drew (not getting mail) 2012-02-21 13:07:43 PST
Oh wait, I misunderstood Erin's comment.
Comment 5 Joe Drew (not getting mail) 2012-02-21 13:09:09 PST
This doesn't show up on the main demo site, just on http://jsbin.com/isujul
Comment 6 Ali Juma [:ajuma] 2012-02-28 08:26:06 PST
(In reply to Paul Rouget [:paul] from comment #3)
> The original demo is here: http://jsbin.com/isujul

It doesn't seem to be anymore. Can the original demo be found anywhere else?
Comment 7 Joe Drew (not getting mail) 2012-03-08 11:07:14 PST
This is a very, very bad bug that indicates we're not clipping layers properly, and it's not restricted to this page (I've seen it elsewhere). I'd like it to be re-evaluated.

Meanwhile, I've put this demo up on my personal server. Mats, can you see what's causing this?
Comment 8 Brad Lassey [:blassey] (use needinfo?) 2012-03-08 12:06:30 PST
solid justification to block on it
Comment 9 Jet Villegas (:jet) 2012-03-23 14:14:44 PDT
Mats, can you comment on your latest findings here? Thx.
Comment 10 Naoki Hirata :nhirata (please use needinfo instead of cc) 2012-03-30 14:06:34 PDT
This issue still occurs on the Galaxy Nexus (Nightly 3/30/2012) going to http://paulrouget.com/mwc-demos/apis/ and clicking on the "view on a map" button.  If you do not see the issue on load, try panning in the map area.
Comment 11 Erin Lancaster [:elan] 2012-04-09 10:23:04 PDT
Fennec Native needs to be at zero beta blockers by 04/16. Who should this be assigned to?
Comment 12 Brad Lassey [:blassey] (use needinfo?) 2012-04-11 08:11:46 PDT
sorry,  moving the product and component apparently unassigned the bug. Mats, has this been on your radar?
Comment 13 Mats Palmgren (vacation) 2012-04-11 10:43:26 PDT
I looked at this a couple of weeks ago, and I could reproduce it at that time
but I can't say I understood what the problem is.  I've been working on other
stuff since then (security bugs mostly).  I'll take another look later tonight
and see what I can find this time...
Comment 14 JP Rosevear [:jpr] 2012-04-13 10:57:34 PDT
Roc, do you agree with #7.
Comment 15 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2012-04-13 15:49:19 PDT
I don't know. Nightly doesn't really work on my phone recently. (Maybe since I enabled Sync?)

I don't have time to work on this anyway. I'm working on display-list performance instead.
Comment 16 Jet Villegas (:jet) 2012-04-15 15:50:53 PDT
Back to Mats: Please update with your latest findings.
Comment 17 Mats Palmgren (vacation) 2012-04-16 09:09:38 PDT
I have nothing new to add really, the bug still occurs and I don't know what
the problem is.
Comment 18 Mats Palmgren (vacation) 2012-04-19 10:15:07 PDT
The Google maps content is rather complex, it's many nested levels of abs.pos.
blocks with different z-index and the whole DOM is built dynamically.

The root cause of this bug appears to come from a transition of 'opacity':
<div style="width: 256px; height: 256px; position: absolute; left: -48px; top: 23px; opacity: 1; -moz-transition: opacity 200ms ease-out 0s;">

As a workaround for this particular demo site, adding this cures the flicker:
  <style> div { -moz-transition: none !important; } </style>

(FYI, bug 728983 is fixed in this tree, but it didn't help)
Comment 19 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2012-04-19 15:49:49 PDT
Transitioning opacity creates a layer for the element with opacity. Seems like a reduced testcase is needed...
Comment 20 Mats Palmgren (vacation) 2012-04-21 19:20:11 PDT
Created attachment 617271 [details]
Testcase #1
Comment 21 Damon Sicore (:damons) 2012-04-23 11:35:24 PDT
Do we have a path forward here or are we stuck?

Mats, these Firefox on Android bugs are top priority and require immediate and persistent attention until resolution.
Comment 22 Mats Palmgren (vacation) 2012-04-23 14:14:41 PDT
The bug doesn't occur when useIntermediateSurface is true in this method:
http://mxr.mozilla.org/mozilla-central/source/gfx/layers/Layers.cpp#457

The bug doesn't occur with this change:
-  if (opacity != 1.0f && HasMultipleChildren()) {
+  if (opacity != 1.0f) {


=> GFX
Comment 23 Joe Drew (not getting mail) 2012-04-24 09:02:04 PDT
I'm going to look at this now.
Comment 24 Joe Drew (not getting mail) 2012-04-24 15:32:25 PDT
It seems that this is being caused by the scissor bit being disabled on us.
Comment 25 Joe Drew (not getting mail) 2012-04-26 15:30:36 PDT
Created attachment 618823 [details] [diff] [review]
don't disable the scissor rect from java

This fixes the bug that we haven't been clipping at all inside the layers system. Unfortunately, this exposes latent bugs in our layers/layout system that must be fixed before we can land this.
Comment 26 Jeff Muizelaar [:jrmuizel] 2012-04-26 23:54:35 PDT
Comment on attachment 618823 [details] [diff] [review]
don't disable the scissor rect from java

Perhaps add a comment about the expected scissor state in the different situations. e.g. at drawBackground/drawForeground
Comment 27 Joe Drew (not getting mail) 2012-04-30 08:13:16 PDT
Created attachment 619566 [details] [diff] [review]
unbitrotted

This is just an unbitrotted version of the previous patch. Carrying forward r+.
Comment 28 Joe Drew (not getting mail) 2012-05-02 08:28:57 PDT
Created attachment 620326 [details] [diff] [review]
unbitrotted again

Re-unbitrotted. Carrying forward r+.
Comment 29 Joe Drew (not getting mail) 2012-05-02 11:40:02 PDT
Created attachment 620402 [details] [diff] [review]
unbitrotted again
Comment 30 Joe Drew (not getting mail) 2012-05-02 13:54:59 PDT
*** Bug 748485 has been marked as a duplicate of this bug. ***
Comment 31 Joe Drew (not getting mail) 2012-05-02 14:35:44 PDT
*** Bug 747791 has been marked as a duplicate of this bug. ***
Comment 32 Ali Juma [:ajuma] 2012-05-03 12:59:31 PDT
*** Bug 741173 has been marked as a duplicate of this bug. ***
Comment 33 Joe Drew (not getting mail) 2012-05-04 10:59:48 PDT
*** Bug 745167 has been marked as a duplicate of this bug. ***
Comment 34 Joe Drew (not getting mail) 2012-05-08 20:22:08 PDT
https://hg.mozilla.org/mozilla-central/rev/47b65f49d01b
Comment 35 Tony Chung [:tchung] 2012-05-09 00:49:27 PDT
Tested against a build on ftp://ftp.mozilla.org/pub/mobile/tinderbox-builds/oak-android/1336516588/.   I still see the map fragments from the testcase URL quickly resize and redraw, but it doesnt do that outside of the box perimeter like how aurora does.
Comment 36 Benoit Girard (:BenWa) 2012-05-09 07:52:26 PDT
*** Bug 739042 has been marked as a duplicate of this bug. ***
Comment 37 Joe Drew (not getting mail) 2012-05-09 09:56:15 PDT
The quickly resize part is bug 750334.
Comment 38 Mark Finkle (:mfinkle) (use needinfo?) 2012-05-09 13:03:09 PDT
https://hg.mozilla.org/releases/mozilla-aurora/rev/5fe40d328f31
Comment 39 Catalin Suciu [:csuciu] 2012-05-23 04:46:41 PDT
Retested on Nightly 15.0a1 (2012-05-22)
            Aurora 14.0a2 (2012-05-22)
Samsung Galaxy SII (2.3.4)

The map fragments from the testcase are not longer redrawn outside the box perimeter.

Verifying.

Note You need to log in before you can comment on or make changes to this bug.